# **weiz`PVP`** : *__CHANGELOG__*

📌 **Note :**  If you come across any issues or bugs _(even in alpha or beta versions)_, please be sure to report them with any details you have. _(Screenshots and video clips help a ton for visual/UI issues.)_

Please state what version you are running when reporting issues. To check your version, run '`/wpvp ver`' or look under the interface options, listed at the top.

----

## **Version** : `v1.23`

### 🛠️ **CODE & BACKEND**
* Fixed a number of bugs while looking into sorting issues.
    * Sorting issues out of combat seem resolved.
    * Optimizations in list management.

----

## **Version** : `v1.2-release`

### 📐 **INTERFACE & DESIGN**
* Adjusted Crosshair some animations and textures.


### 🛠️ **CODE & BACKEND**
* Cleaned up assets and old comments for release.
* Optimized some code dealing with list management.

----

## **Version** : `v1.2-beta1`

### 📐 **INTERFACE & DESIGN**
* Reworked Crosshairs look and functionality.
    * Pixel-perfect redesign of image assets and placement.
    * Changed some texture being used to bring everything together a little tighter.
    * Adjusted some animations.
    * Added option to show target name and guild.

### 🎛️ **FUNCTIONALITY**
* Reworked Crosshairs functionality.
    * Added changing of colors and opacity based on distance from target.

### 🛠️ **CODE & BACKEND**
* Added some code to throttled the gathering of some player information as to not use too much CPU in larger (40vs40+) fights.
* Cleaned up code and media assets for beta; more planned when it's ready to go live.
* Fixed a few small/less frequent issues with Crosshairs not finding a player's nameplate to lock on to.

----

## **Version** : `v1.2-alpha6`

### 📐 **INTERFACE & DESIGN**
* Updated, created, and pixel-adjusted many art assets.
* Changed the style of the crosshair. Plans to have options to change the look in future.
* Colors and elements on crosshairs change depending on if they're within ~40 yards.
* Fine tuned and created new functions to adjust class colors for different elements in a more controlled manner.
* Started creating more layers for the crosshair to display more data:
    * Name
    * Guild Name
    * Indicators for when your target is targeting you.
    * More planned (eventual nameplate replacement for targets)
* New options section for added changes to crosshair so they can be enabled/disabled.
    * _(Most new things are disabled by default.)_

### 🎛️ **FUNCTIONALITY**
* Added a new command: '`/wpvp ver`' to display the current version of weizPVP that is installed and running.
    * _(You can also check the version via the Interface Options)_
* Fixed some layering issues with crosshairs.
* Fixed issue when a crosshair was looking for a nameplate that wasn't created yet, even if a player is targeted.


### 🛠️ **CODE & BACKEND**
* Continuing work on optimizing code as I come across it while fixing bugs and adding new features.
    * New methods are being used to now to help reduce the number of variables used and logic needed; reducing memory and CPU usage _**(which is doing quite well as it is)**_

* After cleaning out unused assets that were initially planned to be used much sooner, the package size of the addon is down to about **530KB**, far less than version 1.13's **1.9MB**.
    * Most of the previous assets were not doing much other than registering with LibSharedMedia to be used with other addons if desired, but otherwise weren't doing much after being initially loaded.
    * Some reduction of size has been due to reduced code and better designed data tables as well, though the bulk was easily from media assets.


----

## **Version** : `v1.2-alpha5`

### 🎛️ **FUNCTIONALITY**
* Fixed a number of small, infrequent bugs relating to the crosshair code.
* The targeted nameplate should now always show on top of the crosshair UI, as to avoid covering names/health bars, etc.
    * These updates are done every so often to ensure proper layering of the nameplate, crosshair, and other UI elements.

### 📐 **INTERFACE & DESIGN**
* Some more UI tweaks on the crosshair to keep them visible and dynamic, but no too overwhelming.

----

## **Version** : `v1.2-alpha4`

### 🎛️ **FUNCTIONALITY**
* Changes to the crosshairs again; both design and code. Both are better. Further additions to the crosshairs will be very simple and quick.
* 🎁 As per request, an options is now available that allows you to play an alert when a new enemy is added to the list.
    * This is disabled by default.
    * Picked a sound that someone  would notice, but it isn't obnoxious.
    * You can change this settings under Interface Options or via the command: _**`/wpvp config`**_

----

## **Version** : `v1.2-alpha3`

### 🎛️ **FUNCTIONALITY**
* Updated the crosshair code and assets for a more optimized experience and a better look.
* Fixes an issue where the crosshairs were not 100% locked to the nameplate after the crosshair was moved to the nameplate location
    * _The crosshairs tended to lag behind slightly, especially while tuning the camera quickly. This is now fixed._
* Optimized how settings are being loaded. Still work to do in creating a universal system for updating settings when they get added or forces to a certain parameter.
* Added in an option for an audio alert when a new player is detected that was not already on the list.
    * *The playing of the sound is throttled so that it wont play multiple times over itself, preventing being ear spammed. The softer sound was used to help let you know, but without being annoying is heard semi-often.*

----
## **Version** : `1.2-alpha2`

### 🎛️ **FUNCTIONALITY**
* Added options to allow being enabled in Battlegrounds.
    * Addon settings can be accessed via WoW's Interface Options.
----

## **Version** : `1.2-alpha1`

### 📐 **INTERFACE & DESIGN**
* Player bars now will show the role of the player. Unknown icon show if not determined yet.
* Created a set of custom role icons.
* A number of small changes to the refresh and min/max window buttons. No more overlapping of clickable areas.
* Changed the look of the targeted player to make it a little cleaner and use less code and assets.
* The crosshairs should now move at the same speed, no matter what your FPS is. Moving speed has been slightly increased.
* Small fix to crosshairs were the lines were briefly not going to the edge of the screen when initially changing targets.
* Stabilized the player list to prevent rearranging of order when a lot of players are detected at once.
* **Increased** player timeouts to 31 _`(up from 22)`_ seconds to allow 30 second refreshing buffs from traits and other spells to kick in before we remove them from the list.
    * *Active' player timeout is still set to 14 seconds to keep players on top who are more active (casts/swings/targets/etc.)*
* Mouseover highlighting of player bars modified; now highlights under the text and icons on the bar.
* Stealth Alert popup has been fixed so that background fits inside of the borders.

### 🎛️ **FUNCTIONALITY**
* Improved detection of players.
* Health updates now happen more often.
* Players will not longer to marked as inactive while their nameplates are still visible.
* Player Roles are now detected based on spells and abilities seen in the combat log.
* Fixed *some* issues with the player bars not showing a stealth player as being stealth.
* No longer a delay in saving the window position and dimensions when you resize or move.

### 📘 **MISC NOTES**
* Cleaned up unused media assets, code, and files.

---

## **Version** : `1.13`

### 📐 **INTERFACE & DESIGN**
* Minor changes to bar textures.

### 🎛️ **FUNCTIONALITY**
* Addressed Issue #13 on Curseforge: Pinning options are now synced across methods (slash, right click, interface options).
* Slash commands for lock and pin now toggle on/off.
    * The 'unpin' and 'unlock' slash commands removed as there is one command to toggle them.

---

## **Version** : `1.12`

### 📐 **INTERFACE & DESIGN**
* Added an indicator to the player bars to show your target.
* Added small animation effects to min/max button.
* Resizing the main window will now snap at heights that show only complete bars. No more cutoff bars; Perfection.
* Clamping of the window to the screen has been improved. No part of the window should be able to be moved off-screen anymore.
* Scrolling now correctly scrolls in even increments based on the size and spacing of the player bars.
* Right-Clicking on the title bar at the top of the addon addon will now toggle the 'pin' option, and will output in chat to let you know as well.
* Window location and size is now saved between sessions.

### 🎛️ **FUNCTIONALITY**
* The addon is now disabled in all instances (even BGs and Arenas). This may change later, but in order to have it work properly a decent big of work is required as they use additional API calls specific to the instance.
